#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include "keyb.h"
#include "lcd.h"

int readNumber() {
	char input[6];
	uint8_t inputIndex = 0;
	while(inputIndex < (sizeof(input) - 1)) {
		uint8_t key = 0;
		key = getKey();
		if (key == 15) {
			if (inputIndex > 0) {
				inputIndex--;
				lcdWriteCommand(LCD_COMMAND_SHIFT);
				printf("%c", ' ');
				lcdWriteCommand(LCD_COMMAND_SHIFT);
			}
			continue;
		}
		if (key < 10) input[inputIndex] = '0' + key;
		if (key == 10) input[inputIndex] = '0';
		if (key == 16) {
			break;
		}
		printf("%c", input[inputIndex]);
		inputIndex++;
	}
	input[inputIndex] = 0;
	return atoi(input);
}

uint8_t readKeyboard() {
	for (uint8_t row = 0; row < 4; row++){
		KEYB_PORT = ~_BV(row);
		_delay_us(1);
		for (uint8_t column = 0; column < 4; column++){
			if (~KEYB_PIN & _BV(column + 4)) {
				return row * 4 + column + 1;
			}
		}
	}
	return 0;
}

uint8_t getKey() {
	uint8_t key = 0;
	while (!(key = readKeyboard()));
	while (readKeyboard());
	return key;
}

void keybInit() {
	KEYB_DDR = 0x0f;
}