#include <avr/io.h>
#include "lcd.h"
#include "keyb.h"

int main(void)
{
	lcdInit();
	lcdInitPrintf();
	keybInit();
	TCCR1B = _BV(WGM12) | _BV(CS12) | _BV(CS10);
	OCR1A = 15624;
	lcdWriteCommand(LCD_COMMAND_ON_OFF | LCD_PARAM_ON_OFF_DISPLAY | LCD_PARAM_ON_OFF_CURSOR);
	printf("  :  :  ");
	lcdGotoXY(0, 0);
	uint8_t hours, minutes, seconds;
	readTime(&hours, &minutes, &seconds);
	lcdWriteCommand(LCD_COMMAND_ON_OFF | LCD_PARAM_ON_OFF_DISPLAY);
	TIFR |= _BV(OCF1A);
	while(1) {
		while(!(TIFR & _BV(OCF1A)));
		TIFR |= _BV(OCF1A);
		lcdGotoXY(0, 0);
		printf("%.2u:%.2u:%.2u", hours, minutes, seconds);
		seconds++;
		if (seconds == 60) {
			seconds = 0;
			minutes++;
		}
		if (minutes == 60) {
			minutes = 0;
			hours++;
		}
		if (hours == 24) {
			hours = 0;
		}
	}
}
